#include "common.h"
#include "config.h"
#include "console.h"
#include "io.h"

char config_buf[CONFIG_BUFSIZE];
volatile bool do_update_config;
bool _configured;

void update_config(void)
{
    do_update_config = false;

    memcpy(sysvar_val, config_buf, (size_t)sysvar_count * sizeof *sysvar_val);

    con_puts("[ESP] Configuration received: ");
    con_puts(_configured ? "update\n" : "initial\n");

    if (!_configured) {
	_configured = true;
	return;
    }

    uint32_t busctl = ABC_BUSCTL;

    if (getvar_bool(config_abc_reset)) {
	ABC_BUSCTL = busctl | ABC_BUSCTL_RESET;
	udelay(20000);
    }
    if (getvar_bool(config_fpga_reset)) {
	reset(SYS_RESET_SOFT);
    }
    ABC_BUSCTL = busctl;
}
